diff --git a/README b/README
index 428e45549a88..bf6b8cd4d658 100644
--- a/README
+++ b/README
@@ -52,7 +52,6 @@ provided by your OS distributor:
     * Development install of zlib (e.g., zlib-dev)
     * Development install of Python 2.7 or later (e.g., python-dev)
     * Development install of curses (e.g., libncurses-dev)
-    * Development install of openssl (e.g., openssl-dev)
     * Development install of x11 (e.g. xorg-x11-dev)
     * Development install of uuid (e.g. uuid-dev)
     * Development install of yajl (e.g. libyajl-dev)
diff --git a/automation/build/debian/bookworm-arm64v8.dockerfile b/automation/build/debian/bookworm-arm64v8.dockerfile
index 3ab426a082d3..a36b04e75e95 100644
--- a/automation/build/debian/bookworm-arm64v8.dockerfile
+++ b/automation/build/debian/bookworm-arm64v8.dockerfile
@@ -15,7 +15,6 @@ RUN apt-get update && \
         build-essential \
         zlib1g-dev \
         libncurses5-dev \
-        libssl-dev \
         python3-dev \
         python3-setuptools \
         xorg-dev \
diff --git a/automation/build/debian/bookworm-i386.dockerfile b/automation/build/debian/bookworm-i386.dockerfile
index 9a54bd7293dc..2ccf32193f26 100644
--- a/automation/build/debian/bookworm-i386.dockerfile
+++ b/automation/build/debian/bookworm-i386.dockerfile
@@ -17,7 +17,6 @@ RUN apt-get update && \
         build-essential \
         zlib1g-dev \
         libncurses5-dev \
-        libssl-dev \
         python3-dev \
         python3-setuptools \
         xorg-dev \
diff --git a/automation/build/debian/bookworm.dockerfile b/automation/build/debian/bookworm.dockerfile
index bef44dd75300..d02e3df61f76 100644
--- a/automation/build/debian/bookworm.dockerfile
+++ b/automation/build/debian/bookworm.dockerfile
@@ -15,7 +15,6 @@ RUN apt-get update && \
         build-essential \
         zlib1g-dev \
         libncurses5-dev \
-        libssl-dev \
         python3-dev \
         python3-setuptools \
         xorg-dev \
diff --git a/automation/build/debian/jessie-i386.dockerfile b/automation/build/debian/jessie-i386.dockerfile
index 1eb7ff11c7d3..d66d0692029b 100644
--- a/automation/build/debian/jessie-i386.dockerfile
+++ b/automation/build/debian/jessie-i386.dockerfile
@@ -24,7 +24,6 @@ RUN apt-get update && \
         build-essential \
         zlib1g-dev \
         libncurses5-dev \
-        libssl-dev \
         python-dev \
         xorg-dev \
         uuid-dev \
diff --git a/automation/build/debian/jessie.dockerfile b/automation/build/debian/jessie.dockerfile
index 4c0ffe66f8fe..53c3bb28f175 100644
--- a/automation/build/debian/jessie.dockerfile
+++ b/automation/build/debian/jessie.dockerfile
@@ -22,7 +22,6 @@ RUN apt-get update && \
         build-essential \
         zlib1g-dev \
         libncurses5-dev \
-        libssl-dev \
         python-dev \
         xorg-dev \
         uuid-dev \
diff --git a/automation/build/debian/stretch-i386.dockerfile b/automation/build/debian/stretch-i386.dockerfile
index 8ec9c3a24667..36108335e5c7 100644
--- a/automation/build/debian/stretch-i386.dockerfile
+++ b/automation/build/debian/stretch-i386.dockerfile
@@ -24,7 +24,6 @@ RUN apt-get update && \
         build-essential \
         zlib1g-dev \
         libncurses5-dev \
-        libssl-dev \
         python-dev \
         python3-dev \
         xorg-dev \
diff --git a/automation/build/debian/stretch.dockerfile b/automation/build/debian/stretch.dockerfile
index 2db4552662de..c5339d3c835f 100644
--- a/automation/build/debian/stretch.dockerfile
+++ b/automation/build/debian/stretch.dockerfile
@@ -22,7 +22,6 @@ RUN apt-get update && \
         build-essential \
         zlib1g-dev \
         libncurses5-dev \
-        libssl-dev \
         python-dev \
         python3-dev \
         xorg-dev \
diff --git a/automation/build/fedora/29.dockerfile b/automation/build/fedora/29.dockerfile
index 08edf70838f9..d5f017ac723d 100644
--- a/automation/build/fedora/29.dockerfile
+++ b/automation/build/fedora/29.dockerfile
@@ -10,7 +10,6 @@ RUN dnf -y install \
         gcc-c++ \
         ncurses-devel \
         zlib-devel \
-        openssl-devel \
         python-devel \
         python3-devel \
         libuuid-devel \
diff --git a/automation/build/ubuntu/bionic.dockerfile b/automation/build/ubuntu/bionic.dockerfile
index cc43fc4ade12..c83624e8ca1e 100644
--- a/automation/build/ubuntu/bionic.dockerfile
+++ b/automation/build/ubuntu/bionic.dockerfile
@@ -15,7 +15,6 @@ RUN apt-get update && \
         build-essential \
         zlib1g-dev \
         libncurses5-dev \
-        libssl-dev \
         python-dev \
         python3-dev \
         xorg-dev \
diff --git a/automation/build/ubuntu/focal.dockerfile b/automation/build/ubuntu/focal.dockerfile
index cb8bb2f6faee..cabbebf37754 100644
--- a/automation/build/ubuntu/focal.dockerfile
+++ b/automation/build/ubuntu/focal.dockerfile
@@ -15,7 +15,6 @@ RUN apt-get update && \
         build-essential \
         zlib1g-dev \
         libncurses5-dev \
-        libssl-dev \
         python3-dev \
         python3-setuptools \
         xorg-dev \
diff --git a/automation/build/ubuntu/trusty.dockerfile b/automation/build/ubuntu/trusty.dockerfile
index e2a1bda7c3a8..ecbcb71b1c21 100644
--- a/automation/build/ubuntu/trusty.dockerfile
+++ b/automation/build/ubuntu/trusty.dockerfile
@@ -15,7 +15,6 @@ RUN apt-get update && \
         build-essential \
         zlib1g-dev \
         libncurses5-dev \
-        libssl-dev \
         python-dev \
         python3-dev \
         xorg-dev \
diff --git a/automation/build/ubuntu/xenial.dockerfile b/automation/build/ubuntu/xenial.dockerfile
index 168bc70ffad8..13ecae7a0b81 100644
--- a/automation/build/ubuntu/xenial.dockerfile
+++ b/automation/build/ubuntu/xenial.dockerfile
@@ -15,7 +15,6 @@ RUN apt-get update && \
         build-essential \
         zlib1g-dev \
         libncurses5-dev \
-        libssl-dev \
         python-dev \
         python3-dev \
         xorg-dev \
diff --git a/automation/tests-artifacts/kernel/5.19-arm64v8.dockerfile b/automation/tests-artifacts/kernel/5.19-arm64v8.dockerfile
index 22359c906630..8e33995ba34b 100644
--- a/automation/tests-artifacts/kernel/5.19-arm64v8.dockerfile
+++ b/automation/tests-artifacts/kernel/5.19-arm64v8.dockerfile
@@ -14,7 +14,6 @@ WORKDIR /build
 RUN apt-get update && \
     apt-get --quiet --yes install \
         build-essential \
-        libssl-dev \
         bc \
         curl \
         flex \
diff --git a/automation/tests-artifacts/kernel/6.1.19.dockerfile b/automation/tests-artifacts/kernel/6.1.19.dockerfile
index 5cf53d290c6f..073eaa0e11fa 100644
--- a/automation/tests-artifacts/kernel/6.1.19.dockerfile
+++ b/automation/tests-artifacts/kernel/6.1.19.dockerfile
@@ -14,7 +14,6 @@ WORKDIR /build
 RUN apt-get update && \
     apt-get --quiet --yes install \
         build-essential \
-        libssl-dev \
         bc \
         curl \
         flex \