diff --git a/README b/README
index bf6b8cd4d658..560247e7103c 100644
--- a/README
+++ b/README
@@ -52,7 +52,6 @@ provided by your OS distributor:
     * Development install of zlib (e.g., zlib-dev)
     * Development install of Python 2.7 or later (e.g., python-dev)
     * Development install of curses (e.g., libncurses-dev)
-    * Development install of x11 (e.g. xorg-x11-dev)
     * Development install of uuid (e.g. uuid-dev)
     * Development install of yajl (e.g. libyajl-dev)
     * Development install of libaio (e.g. libaio-dev) version 0.3.107 or
diff --git a/automation/build/debian/bookworm-arm64v8.dockerfile b/automation/build/debian/bookworm-arm64v8.dockerfile
index a36b04e75e95..11acc07bff0e 100644
--- a/automation/build/debian/bookworm-arm64v8.dockerfile
+++ b/automation/build/debian/bookworm-arm64v8.dockerfile
@@ -17,7 +17,6 @@ RUN apt-get update && \
         libncurses5-dev \
         python3-dev \
         python3-setuptools \
-        xorg-dev \
         uuid-dev \
         libyajl-dev \
         libaio-dev \
diff --git a/automation/build/debian/bookworm-i386.dockerfile b/automation/build/debian/bookworm-i386.dockerfile
index 2ccf32193f26..66fa3121c54e 100644
--- a/automation/build/debian/bookworm-i386.dockerfile
+++ b/automation/build/debian/bookworm-i386.dockerfile
@@ -19,7 +19,6 @@ RUN apt-get update && \
         libncurses5-dev \
         python3-dev \
         python3-setuptools \
-        xorg-dev \
         uuid-dev \
         libyajl-dev \
         libaio-dev \
diff --git a/automation/build/debian/bookworm.dockerfile b/automation/build/debian/bookworm.dockerfile
index d02e3df61f76..db866fde3074 100644
--- a/automation/build/debian/bookworm.dockerfile
+++ b/automation/build/debian/bookworm.dockerfile
@@ -17,7 +17,6 @@ RUN apt-get update && \
         libncurses5-dev \
         python3-dev \
         python3-setuptools \
-        xorg-dev \
         uuid-dev \
         libyajl-dev \
         libaio-dev \
diff --git a/automation/build/debian/jessie-i386.dockerfile b/automation/build/debian/jessie-i386.dockerfile
index d66d0692029b..dfa6dae06cb8 100644
--- a/automation/build/debian/jessie-i386.dockerfile
+++ b/automation/build/debian/jessie-i386.dockerfile
@@ -25,7 +25,6 @@ RUN apt-get update && \
         zlib1g-dev \
         libncurses5-dev \
         python-dev \
-        xorg-dev \
         uuid-dev \
         libyajl-dev \
         libaio-dev \
diff --git a/automation/build/debian/jessie.dockerfile b/automation/build/debian/jessie.dockerfile
index 53c3bb28f175..82dae9ec70c4 100644
--- a/automation/build/debian/jessie.dockerfile
+++ b/automation/build/debian/jessie.dockerfile
@@ -23,7 +23,6 @@ RUN apt-get update && \
         zlib1g-dev \
         libncurses5-dev \
         python-dev \
-        xorg-dev \
         uuid-dev \
         libyajl-dev \
         libaio-dev \
diff --git a/automation/build/debian/stretch-i386.dockerfile b/automation/build/debian/stretch-i386.dockerfile
index 36108335e5c7..905096ab0ef1 100644
--- a/automation/build/debian/stretch-i386.dockerfile
+++ b/automation/build/debian/stretch-i386.dockerfile
@@ -26,7 +26,6 @@ RUN apt-get update && \
         libncurses5-dev \
         python-dev \
         python3-dev \
-        xorg-dev \
         uuid-dev \
         libyajl-dev \
         libaio-dev \
diff --git a/automation/build/debian/stretch.dockerfile b/automation/build/debian/stretch.dockerfile
index c5339d3c835f..b99d229acf14 100644
--- a/automation/build/debian/stretch.dockerfile
+++ b/automation/build/debian/stretch.dockerfile
@@ -24,7 +24,6 @@ RUN apt-get update && \
         libncurses5-dev \
         python-dev \
         python3-dev \
-        xorg-dev \
         uuid-dev \
         libyajl-dev \
         libaio-dev \
diff --git a/automation/build/ubuntu/bionic.dockerfile b/automation/build/ubuntu/bionic.dockerfile
index c83624e8ca1e..c1effc725e17 100644
--- a/automation/build/ubuntu/bionic.dockerfile
+++ b/automation/build/ubuntu/bionic.dockerfile
@@ -17,7 +17,6 @@ RUN apt-get update && \
         libncurses5-dev \
         python-dev \
         python3-dev \
-        xorg-dev \
         uuid-dev \
         libyajl-dev \
         libaio-dev \
diff --git a/automation/build/ubuntu/focal.dockerfile b/automation/build/ubuntu/focal.dockerfile
index cabbebf37754..b49e53d185b4 100644
--- a/automation/build/ubuntu/focal.dockerfile
+++ b/automation/build/ubuntu/focal.dockerfile
@@ -17,7 +17,6 @@ RUN apt-get update && \
         libncurses5-dev \
         python3-dev \
         python3-setuptools \
-        xorg-dev \
         uuid-dev \
         libyajl-dev \
         libaio-dev \
diff --git a/automation/build/ubuntu/trusty.dockerfile b/automation/build/ubuntu/trusty.dockerfile
index ecbcb71b1c21..1cda1bbd3fea 100644
--- a/automation/build/ubuntu/trusty.dockerfile
+++ b/automation/build/ubuntu/trusty.dockerfile
@@ -17,7 +17,6 @@ RUN apt-get update && \
         libncurses5-dev \
         python-dev \
         python3-dev \
-        xorg-dev \
         uuid-dev \
         libyajl-dev \
         libaio-dev \
diff --git a/automation/build/ubuntu/xenial.dockerfile b/automation/build/ubuntu/xenial.dockerfile
index 13ecae7a0b81..aa8f560286b6 100644
--- a/automation/build/ubuntu/xenial.dockerfile
+++ b/automation/build/ubuntu/xenial.dockerfile
@@ -17,7 +17,6 @@ RUN apt-get update && \
         libncurses5-dev \
         python-dev \
         python3-dev \
-        xorg-dev \
         uuid-dev \
         libyajl-dev \
         libaio-dev \